{ File   : QSort.pas
  Author : Deniz Oezmen
  Created: 2005-09-06
  Changed: 2007-03-18

  Some inefficient quicksort implementation.
}
unit QSort;

interface

type
  // TLessFunc should return True iff DataA < DataB
  TLessFunc = function(var DataA, DataB): Boolean;

// InData should by a dynamic array of some base type with size TypeSize
procedure QuickSort(var InData; TypeSize: Longint; const Less: TLessFunc);

implementation

procedure QuickSort(var InData; TypeSize: Longint; const Less: TLessFunc);
type
  TData = array of Byte;
var
  Data: TData;

  procedure QSort(l, r: Longint);
  var
    Data,
    Pivot,
    t    : TData;
    LIdx,
    RIdx : Longint;
  begin
    Data := TData(InData);
    SetLength(Pivot, TypeSize);
    SetLength(t, TypeSize);

    if r <= l then
      Exit;

    Move(Data[((Random(r - l + 1) + l) div TypeSize) * TypeSize],
      Pivot[0], TypeSize);

    LIdx := l;
    RIdx := r;

    while LIdx <= RIdx do
    begin
      while Less(Data[LIdx], Pivot[0]) do
        Inc(LIdx, TypeSize);
      while Less(Pivot[0], Data[RIdx]) do
        Dec(RIdx, TypeSize);

      if LIDx > RIdx then
        Break;

      Move(Data[LIdx], t[0], TypeSize);
      Move(Data[RIdx], Data[LIdx], TypeSize);
      Move(t[0], Data[RIdx], TypeSize);

      Inc(LIdx, TypeSize);
      Dec(RIdx, TypeSize)
    end;

    if l < RIdx then
      QSort(l, RIdx);
    if LIdx < r then
      QSort(LIdx, r);

    Finalize(Pivot);
    Finalize(t)
  end;

begin
  Data := TData(InData);
  QSort(Low(Data) * TypeSize, High(Data) * TypeSize)
end;

end.
